<?xml version="1.0"?>
<!--@+leo-->

<!--@+node:0::@file sbx_slide.xsl-->
<!--@+body-->
<!--@@first <?xml version="1.0"?>-->
<!--@@language html-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

<xsl:variable name="pageCount" select="count(/screenbook/pages/page)"/>

<!--@<< main template >>-->
<!--@+node:1::<< main template >>-->
<!--@+body-->
<!--@@code-->

<xsl:template match="/">
<files>
  <xsl:for-each select="screenbook/pages/page">  
    <file>
      <html>
        
<!--@<< head >>-->
		<!--@+node:1::<< head >>-->
		<!--@+body-->
		 <head>
		    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/> 
		    <meta name="keywords" content="{../../keywords}" />
		    <meta name="description" content="{../../description}"/>
		    <title>
		    <xsl:value-of select="../../title"/> : <xsl:value-of select="title"/>
		    </title>
		    <link rel='stylesheet' type='text/css' href='../../../../sbook1.css'/>
		    <script src='../../../../sbook.js'></script>
		    <script>init2()</script>
			<style type="text/css">
			BODY {margin-top:0}
			</style>
		  </head>
		<!--@-body-->
		<!--@-node:1::<< head >>-->

	    
<!--@<< body >>-->
		<!--@+node:2::<< body >>-->
		<!--@+body-->
		<!--@@code-->
		
		  <body>
		    
		<!--@<< layer 1 >>-->
			<!--@+node:1::<< layer 1 >>-->
			<!--@+body-->
			<!--@+doc-->
			<!--
			
			
			The nav bar.
			

			-->

			<!--@-doc-->
			<!--@@code-->
			
			    <xsl:variable name="myIndex"><xsl:if test="position() &lt; 10">0</xsl:if><xsl:value-of select="position()"/></xsl:variable>
			    <div id='Layer1' style='position:absolute; width:640px; height:30px; z-index:2; left: 10x; top: 1px'> 
			    <table>
			      <tr>
			      <td width='32' nowrap="nowrap" class='navbar' title='Look for more Screenbooks at Screenbooks.net'>
			      <a href='http://www.evisa.com/e/sb.htm' target='_top'><img src='../../../../home.gif' width='18' height='14' border='0'/></a><xsl:text>
				  </xsl:text>
			      </td>
			      <td width='32' nowrap="nowrap" class='navbar' title='Search this bookshelf'>
			      <a href='../../../../search.htm' target='_top'><img src='../../../../search.gif' width='18' height='14' border='0'/></a><xsl:text>
				  </xsl:text>
			      </td>
			
			      <td width='30' nowrap="nowrap" class='navbar' title='View this page with no frames'>
			      <a target='_top'>
				  <xsl:attribute name="href">slide<xsl:value-of select="$myIndex"/>.htm</xsl:attribute>
				  <img src='../../../../window.gif' border='0' hspace='2' width='30px' height='14px'/></a><xsl:text>
				  </xsl:text>
			      </td>
			
			      <td width='238' nowrap="nowrap" class='navbar'>
			      <a class="menua" href='../../../../custom.htm'>font</a><xsl:text>
			      &#160; </xsl:text>
				  <a class="menua" href='../../../../help_s.htm'>help</a><xsl:text>
			      &#160; </xsl:text>
			      
			      <a class="menua" title='Table of contents of this Bookshelf (Frames)'>
				  <xsl:attribute name="href">javascript:go('sbframetoc.htm?f=slide<xsl:value-of select="$myIndex"/>.htm')</xsl:attribute>
				  bookshelf</a><xsl:text>
				  &#160; </xsl:text>
			      
			      <a class="menua" title='Table of contents of this Screenbook (Frames)'>
				  <xsl:attribute name="href">javascript:go('frametoc.htm?f=slide<xsl:value-of select="$myIndex"/>.htm')</xsl:attribute>	  
				  TOC</a><xsl:text>
				  &#160; </xsl:text>
			      <a class="menua" title='Titles and Thumbnails' href="javascript:go('sbookt.htm')">thumbnails</a>
			      </td>
			
			      <td width='206' nowrap="nowrap" class='navbar'>
			      <b><xsl:value-of select="position()"/> of <xsl:value-of select="$pageCount"/></b><xsl:text>
				  </xsl:text>   
			      </td>
			
			      <td width='40' nowrap="nowrap" class='navbar2' title='Back one page'><xsl:call-template name="prevButton"><xsl:with-param name="myIndex" select="position()" /></xsl:call-template><xsl:text>
			      </xsl:text>
				  </td>
			      <td width='40' nowrap="nowrap" class='navbar2' title='Next page'><xsl:call-template name="nextButton"><xsl:with-param name="myIndex" select="position()" /></xsl:call-template><xsl:text>
			      </xsl:text>
			      </td>
			      </tr>
			    </table>
			    </div>
			

			<!--@-body-->
			<!--@-node:1::<< layer 1 >>-->

			
		<!--@<< layer 2 >>-->
			<!--@+node:2::<< layer 2 >>-->
			<!--@+body-->
			<!--@+doc-->
			<!--
			
			
			The title bar.
			

			-->

			<!--@-doc-->
			<!--@@code-->
			
			<div id='Layer2' class="layer2" > 
			  <table width='640' border='0' align='left' bgcolor='#999999'>
			    <tr>
			    <td class='txt2' style="border:none">&#160;
			    <span class='txt1'>&#160;<xsl:value-of select="/screenbook/category"/> : <xsl:value-of select="/screenbook/subcategory"/></span>
			    <span class='txt3'>&#160; &#160;<xsl:value-of select="/screenbook/title"/></span> &#160;
			    </td>
			    </tr>
			  </table>
			</div>
			<!--@-body-->
			<!--@-node:2::<< layer 2 >>-->

			
		<!--@<< layer 3 >>-->
			<!--@+node:3::<< layer 3 >>-->
			<!--@+body-->
			<!--@+doc-->
			<!--
			
			
			The rest of the page: text, pic, page menu, copyright etc.
			

			-->

			<!--@-doc-->
			<!--@@code-->
			
			    <div id='Layer3' style='position:absolute; width:700px; height:480px; z-index:2; left: 10px; top: 60px'> 
			    
				  <xsl:value-of select="text" disable-output-escaping="yes"/>
			
			      <div class='br1'> &#160; </div>
			      
			      <xsl:call-template name="screenbookImage">
			        <xsl:with-param name="pic" select="picture"/>
			      </xsl:call-template>
			      <xsl:call-template name="screenbookImage2">
			        <xsl:with-param name="pic" select="picture"/>
			      </xsl:call-template>      
			
			      <map name="map1"><area shape="rect" coords="425,0 585,14" href="http://www.screenbooks.net" alt="screenbooks home site" /></map>
			      
				  <br/><br/>
			      <table class="footer" cellpadding="4" width="640"><tr><td valign="middle">	 
				    <xsl:call-template name="pageMenu">
			          <xsl:with-param name="count" select="1"/>
			          <xsl:with-param name="myIndex" select="position()"/>
			        </xsl:call-template>
			      </td></tr></table>
			      
			<!--@<< layer 4 >>-->
				  <!--@+node:1::<< layer 4 >>-->
				  <!--@+body-->
				  <!--@+doc-->
				  <!--
				  
				  
				  This is a layer that only shows up when printing.
				  

				  -->

				  <!--@-doc-->
				  <!--@@code-->
				  
				  <div id='Layer4' class="pageCount">
				     <xsl:value-of select="position()"/> of <xsl:value-of select="$pageCount"/>
				  </div>
				  <!--@-body-->
				  <!--@-node:1::<< layer 4 >>-->

			
				  <div style="width:640px" class="cp">
			      <xsl:call-template name="copyright">
			        <xsl:with-param name="page" select="."/>
			      </xsl:call-template>
			      </div>
				  
				  
				</div>
			<!--@-body-->
			<!--@-node:3::<< layer 3 >>-->

		  </body>

		<!--@-body-->
		<!--@-node:2::<< body >>-->

      </html>
    </file>
  </xsl:for-each>
</files>
</xsl:template>
<!--@-body-->
<!--@-node:1::<< main template >>-->


<!--@<< call-templates >>-->
<!--@+node:2::<< call-templates >>-->
<!--@+body-->
<!--@@code-->


<!--@<< image 1 >>-->
<!--@+node:1::<< image 1 >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="screenbookImage">
  <xsl:param name="pic"/>
  <xsl:choose>
  <xsl:when test="$pic='[Empty]'">
  </xsl:when>  
  <xsl:otherwise>
    <img border="0" src="{$pic}" width="{$pic/@width}" height="{$pic/@height}" class="image1" ismap="ismap" usemap="#map1" />
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:1::<< image 1 >>-->


<!--@<< image 2 >>-->
<!--@+node:2::<< image 2 >>-->
<!--@+body-->
<!--@+doc-->
<!--


This html only gets used during printing.


-->

<!--@-doc-->
<!--@@code-->

<xsl:template name="screenbookImage2">
  <xsl:param name="pic"/>
  <xsl:choose>
  <xsl:when test="$pic='[Empty]'">
  </xsl:when>  
  <xsl:otherwise>
    <img border="0" src="highres/{$pic}" width='1' height='1' class="image2" />
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:2::<< image 2 >>-->


<!--@<< copyright >>-->
<!--@+node:3::<< copyright >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="copyright">
  <xsl:param name="page"/>
  &#160; 
  <xsl:if test="$page/text != '[Empty]' and $page/author != '[Empty]'">
    <span class='cp'>Text Author: <xsl:value-of select="$page/author"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/cp != '[Empty]'">
    <span class='cp'><xsl:value-of select="$page/cp"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/sauthor != '[Empty]'">
    <span class='cp'>Screenshot By: <xsl:value-of select="$page/sauthor"/></span> &#160;  
  </xsl:if>
</xsl:template>
<!--@-body-->
<!--@-node:3::<< copyright >>-->


<!--@<< page menu >>-->
<!--@+node:4::<< page menu >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="pageMenu">
  <xsl:param name="count"/>
  <xsl:param name="myIndex"/>
  <xsl:choose>
  <xsl:when test="$myIndex = $count">
<span class='txt6'><xsl:value-of select="$count"/></span> &#160;
  </xsl:when>
  <xsl:otherwise>
<a class="footer"> 
<xsl:attribute name="href">
<xsl:call-template name="slideName">
<xsl:with-param name="myIndex" select="$count"/>
</xsl:call-template>
</xsl:attribute>
<xsl:value-of select="$count"/>
</a>
  <xsl:text> &#160; </xsl:text>
  </xsl:otherwise>
  </xsl:choose>  
  <xsl:choose>
    <xsl:when test="$count &lt; $pageCount">
      <xsl:call-template name="pageMenu">
        <xsl:with-param name="count" select="$count + 1"/>
        <xsl:with-param name="myIndex" select="$myIndex"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:4::<< page menu >>-->


<!--@<< prev button >>-->
<!--@+node:5::<< prev button >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="prevButton">
  <xsl:param name="myIndex"/>
  <xsl:choose>
    <xsl:when test="$myIndex &gt; 1">
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="slideName">
            <xsl:with-param name="myIndex" select="$myIndex - 1"/>
          </xsl:call-template>
        </xsl:attribute>  
        <xsl:text></xsl:text><img src='../../../../left.gif' border='0' height='14px' width='30px' hspace='2' /><xsl:text></xsl:text>
      </a>
    </xsl:when>
    <xsl:otherwise>&#160; </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:5::<< prev button >>-->


<!--@<< next button >>-->
<!--@+node:6::<< next button >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="nextButton">
  <xsl:param name="myIndex"/>
  <xsl:choose>
    <xsl:when test="$myIndex &lt; $pageCount">
      <a>
        <xsl:attribute name="href">
          <xsl:call-template name="slideName">
            <xsl:with-param name="myIndex" select="$myIndex + 1"/>
          </xsl:call-template>
        </xsl:attribute>  
        <xsl:text></xsl:text><img src='../../../../right.gif' border='0' height='14px' width='30px' hspace='2' /><xsl:text></xsl:text>
      </a>
    </xsl:when>
    <xsl:otherwise>&#160; </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:6::<< next button >>-->


<!--@<< slide name >>-->
<!--@+node:7::<< slide name >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="slideName">
  <xsl:param name="myIndex"/>
  <xsl:text>slide</xsl:text>
  <xsl:choose>
  <xsl:when test="$myIndex &lt; 10">0</xsl:when>
  <xsl:otherwise></xsl:otherwise>
  </xsl:choose>
  <xsl:value-of select="$myIndex"/>
  <xsl:text>.htm</xsl:text>
</xsl:template>
<!--@-body-->
<!--@-node:7::<< slide name >>-->















<!--@-body-->
<!--@-node:2::<< call-templates >>-->

</xsl:stylesheet>

<!--@-body-->
<!--@-node:0::@file sbx_slide.xsl-->
<!--@-leo-->